# Microclimate Developer Tools for VS Code

[![Marketplace](https://img.shields.io/vscode-marketplace/v/IBM.microclimate-tools.svg?label=marketplace&logo=visual-studio-code)](https://marketplace.visualstudio.com/items?itemName=IBM.microclimate-tools)
[![Build Status](https://img.shields.io/travis/com/microclimate-dev2ops/microclimate-vscode-tools/master.svg?logo=travis&label=build)](https://travis-ci.com/microclimate-dev2ops/microclimate-vscode-tools)
[![License](https://img.shields.io/badge/License-EPL%202.0-red.svg?label=license&logo=eclipse)](https://www.eclipse.org/legal/epl-2.0/)
[![Slack](https://img.shields.io/badge/ibm--cloud--tech-blue.svg?logo=slack&label=slack)](https://slack-invite-ibm-cloud-tech.mybluemix.net/)

You can use [Microclimate Developer Tools for Visual Studio Code](https://github.com/microclimate-dev2ops/microclimate-vscode-tools) to develop your [Microclimate](https://microclimate-dev2ops.github.io) projects from within VS Code. Use the tools to access Microclimate features in the comfort of your IDE.

Join us [on Slack](https://slack-invite-ibm-cloud-tech.mybluemix.net) if you have any questions.

## How to install [(Documentation)](https://microclimate-dev2ops.github.io/mdt-vsc-getting-started)

1. Install [VS Code version 1.27 or later](https://code.visualstudio.com/download) and [local Microclimate version 18.12 or later](https://microclimate-dev2ops.github.io/installlocally).
2. Install Microclimate Developer Tools for VS Code from the [VS Code Marketplace](https://marketplace.visualstudio.com/items?itemName=IBM.microclimate-tools) or by searching for "Microclimate" in the [VS Code Extensions view](https://code.visualstudio.com/docs/editor/extension-gallery#_browse-for-extensions).

## How to use [(Documentation)](https://microclimate-dev2ops.github.io/mdt-vsc-tutorial)
- Navigate to the **Explorer** view group and open the **Microclimate** view.
    - Right-click the background of the Microclimate view to access the **New connection** commands.
    - After creating a connection, right-click a connection or project to access the other commands.
- Open the [**Command Palette**](https://code.visualstudio.com/docs/getstarted/userinterface#_command-palette) and type "Microclimate" to see the actions available.

## Features [(Documentation)](https://microclimate-dev2ops.github.io/mdt-vsc-commands-overview)
- View all projects in Microclimate, including application and build statuses.
- Debug Microprofile, Spring, and Node.js Microclimate projects.
- View application and build logs in the VS Code **Output** view.
- View project information similar to the information on the Microclimate **Overview** page.
- Integrate Microclimate validation errors into the VS Code **Problems** view.
- Open a shell session into a Microclimate application container.
- Toggle project auto build and manually initiate project builds.
- Scope your VS Code workspace to a Microclimate project or to your `microclimate-workspace`.
- Disable, enable, and delete projects.
