"use strict";
/*******************************************************************************
 * Copyright (c) 2018 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = require("vscode");
const ConnectionManager_1 = require("../microclimate/connection/ConnectionManager");
const CommandUtil_1 = require("./CommandUtil");
const Logger_1 = require("../Logger");
const translator_1 = require("../constants/strings/translator");
const StringNamespaces_1 = require("../constants/strings/StringNamespaces");
function removeConnectionCmd(connection) {
    return __awaiter(this, void 0, void 0, function* () {
        Logger_1.default.d("removeConnectionCmd invoked");
        if (connection == null) {
            const selected = yield CommandUtil_1.promptForConnection(false);
            if (selected == null) {
                // user cancelled
                Logger_1.default.d("User cancelled project prompt");
                return;
            }
            connection = selected;
        }
        // const removed: boolean = await ConnectionManager.instance.removeConnection(connection);
        return ConnectionManager_1.default.instance.removeConnection(connection)
            .then((result) => {
            if (result) {
                vscode.window.showInformationMessage(translator_1.default.t(StringNamespaces_1.default.CMD_MISC, "removedConnection", { uri: connection.mcUri }));
            }
        });
    });
}
exports.default = removeConnectionCmd;
//# sourceMappingURL=RemoveConnectionCmd.js.map