"use strict";
/*******************************************************************************
 * Copyright (c) 2018, 2019 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
// non-nls-file
var SocketEvents;
(function (SocketEvents) {
    SocketEvents.STATUS_SUCCESS = "success";
    /**
     * Socket events we listen for from Microclimate Portal
     * See MCSocket
     */
    let Types;
    (function (Types) {
        Types["PROJECT_CHANGED"] = "projectChanged";
        Types["PROJECT_STATUS_CHANGED"] = "projectStatusChanged";
        Types["PROJECT_CLOSED"] = "projectClosed";
        Types["PROJECT_DELETION"] = "projectDeletion";
        Types["PROJECT_RESTART_RESULT"] = "projectRestartResult";
        Types["CONTAINER_LOGS"] = "container-logs";
        Types["PROJECT_VALIDATED"] = "projectValidated";
        Types["PROJECT_CREATED"] = "projectCreation";
    })(Types = SocketEvents.Types || (SocketEvents.Types = {}));
    /**
     * Property keys we check in Microclimate socket events
     */
    let Keys;
    (function (Keys) {
        Keys["APP_STATE"] = "appStatus";
        Keys["BUILD_STATE"] = "buildStatus";
        Keys["CLOSED_STATE"] = "state";
        Keys["START_MODE"] = "startMode";
        Keys["BUILD_DETAIL"] = "detailedBuildStatus";
    })(Keys = SocketEvents.Keys || (SocketEvents.Keys = {}));
})(SocketEvents || (SocketEvents = {}));
exports.default = SocketEvents;
//# sourceMappingURL=SocketEvents.js.map