"use strict";
/*******************************************************************************
 * Copyright (c) 2018, 2019 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
const vscode = require("vscode");
/**
 * Wrapper for TreeItem so that we can create standalone TreeItemAdaptables.
 */
class SimpleTreeItem {
    constructor(label, initCollapseState = vscode.TreeItemCollapsibleState.None, children = [], contextID, iconPaths) {
        this.label = label;
        this.initCollapseState = initCollapseState;
        this.children = children;
        this.contextID = contextID;
        this.iconPaths = iconPaths;
        this.treeItem = new vscode.TreeItem(this.label, this.initCollapseState);
        this.treeItem.contextValue = contextID;
        this.treeItem.iconPath = iconPaths;
    }
    toTreeItem() {
        return this.treeItem;
    }
    getChildren() {
        return this.children;
    }
}
exports.SimpleTreeItem = SimpleTreeItem;
//# sourceMappingURL=TreeItemAdaptable.js.map